"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reindex = exports.getNextOrder = void 0;
var common_1 = require("@pnp/common-commonjs");
/**
 * Gets the next order value 1 based for the provided collection
 *
 * @param collection Collection of orderable things
 */
function getNextOrder(collection) {
    return collection.length < 1 ? 1 : (Math.max.apply(null, collection.map(function (i) { return i.order; })) + 1);
}
exports.getNextOrder = getNextOrder;
/**
 * Normalizes the order value for all the sections, columns, and controls to be 1 based and stepped (1, 2, 3...)
 *
 * @param collection The collection to normalize
 */
function reindex(collection) {
    for (var i = 0; i < collection.length; i++) {
        collection[i].order = i + 1;
        if ((0, common_1.hOP)(collection[i], "columns")) {
            reindex(collection[i].columns);
        }
        else if ((0, common_1.hOP)(collection[i], "controls")) {
            reindex(collection[i].controls);
        }
    }
}
exports.reindex = reindex;
//# sourceMappingURL=funcs.js.map