"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var types_js_1 = require("../webs/types.js");
var types_js_2 = require("./types.js");
var sharepointqueryable_js_1 = require("../sharepointqueryable.js");
var extractweburl_js_1 = require("../utils/extractweburl.js");
var operations_js_1 = require("../operations.js");
var odata_1 = require("@pnp/odata-commonjs");
var metadata_js_1 = require("../utils/metadata.js");
var common_1 = require("@pnp/common-commonjs");
types_js_1._Web.prototype.getClientsideWebParts = function () {
    return this.clone(sharepointqueryable_js_1.SharePointQueryableCollection, "GetClientSideWebParts")();
};
types_js_1._Web.prototype.addClientsidePage =
    function (pageName, title, layout, promotedState) {
        if (title === void 0) { title = pageName.replace(/\.[^/.]+$/, ""); }
        return (0, types_js_2.CreateClientsidePage)(this, pageName, title, layout, promotedState);
    };
types_js_1._Web.prototype.loadClientsidePage = function (path) {
    return (0, types_js_2.ClientsidePageFromFile)(this.getFileByServerRelativePath(path));
};
types_js_1._Web.prototype.addRepostPage = function (details) {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var query, r;
        return (0, tslib_1.__generator)(this, function (_a) {
            switch (_a.label) {
                case 0:
                    query = (0, sharepointqueryable_js_1.SharePointQueryableInstance)((0, extractweburl_js_1.extractWebUrl)(this.toUrl()), "_api/sitepages/pages/reposts").configureFrom(this);
                    return [4 /*yield*/, (0, operations_js_1.spPost)(query, (0, odata_1.body)((0, common_1.assign)((0, metadata_js_1.metadata)("SP.Publishing.RepostPage"), details)))];
                case 1:
                    r = _a.sent();
                    return [2 /*return*/, r.AbsoluteUrl];
            }
        });
    });
};
// eslint-disable-next-line max-len
types_js_1._Web.prototype.addFullPageApp = function (pageName, title, componentId, promotedState) {
    if (title === void 0) { title = pageName.replace(/\.[^/.]+$/, ""); }
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var parts, test, partDef, part, page;
        return (0, tslib_1.__generator)(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, this.getClientsideWebParts()];
                case 1:
                    parts = _a.sent();
                    test = new RegExp("{?" + componentId + "}?", "i");
                    partDef = parts.find(function (p) { return test.test(p.Id); });
                    part = types_js_2.ClientsideWebpart.fromComponentDef(partDef);
                    return [4 /*yield*/, this.addClientsidePage(pageName, title, "SingleWebPartAppPage", promotedState)];
                case 2:
                    page = _a.sent();
                    page.addSection().addColumn(12).addControl(part);
                    return [2 /*return*/, page];
            }
        });
    });
};
//# sourceMappingURL=web.js.map