"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var odata_1 = require("@pnp/odata-commonjs");
var types_js_1 = require("../items/types.js");
var types_js_2 = require("./types.js");
var operations_js_1 = require("../operations.js");
var extractweburl_js_1 = require("../utils/extractweburl.js");
var common_1 = require("@pnp/common-commonjs");
var sharepointqueryable_js_1 = require("../sharepointqueryable.js");
(0, odata_1.addProp)(types_js_1._Item, "comments", types_js_2.Comments);
types_js_1._Item.prototype.getLikedBy = function () {
    return (0, operations_js_1.spPost)(this.clone(types_js_1.Item, "likedBy"));
};
types_js_1._Item.prototype.like = function () {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var itemInfo, baseUrl, reputationUrl, likeUrl;
        return (0, tslib_1.__generator)(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, this.getParentInfos()];
                case 1:
                    itemInfo = _a.sent();
                    baseUrl = (0, extractweburl_js_1.extractWebUrl)(this.toUrl());
                    reputationUrl = "_api/Microsoft.Office.Server.ReputationModel.Reputation.SetLike(listID=@a1,itemID=@a2,like=@a3)";
                    likeUrl = (0, common_1.combine)(baseUrl, reputationUrl) + ("?@a1='{" + itemInfo.ParentList.Id + "}'&@a2='" + itemInfo.Item.Id + "'&@a3=true");
                    return [2 /*return*/, (0, operations_js_1.spPost)((0, sharepointqueryable_js_1.SharePointQueryable)(likeUrl))];
            }
        });
    });
};
types_js_1._Item.prototype.unlike = function () {
    return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
        var itemInfo, baseUrl, reputationUrl, likeUrl;
        return (0, tslib_1.__generator)(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, this.getParentInfos()];
                case 1:
                    itemInfo = _a.sent();
                    baseUrl = (0, extractweburl_js_1.extractWebUrl)(this.toUrl());
                    reputationUrl = "_api/Microsoft.Office.Server.ReputationModel.Reputation.SetLike(listID=@a1,itemID=@a2,like=@a3)";
                    likeUrl = (0, common_1.combine)(baseUrl, reputationUrl) + ("?@a1='{" + itemInfo.ParentList.Id + "}'&@a2='" + itemInfo.Item.Id + "'&@a3=false");
                    return [2 /*return*/, (0, operations_js_1.spPost)((0, sharepointqueryable_js_1.SharePointQueryable)(likeUrl))];
            }
        });
    });
};
types_js_1._Item.prototype.getLikedByInformation = function () {
    return this.clone(types_js_1.Item, "likedByInformation").expand("likedby")();
};
//# sourceMappingURL=item.js.map