"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HubSite = exports._HubSite = exports.HubSites = exports._HubSites = void 0;
var tslib_1 = require("tslib");
var sharepointqueryable_js_1 = require("../sharepointqueryable.js");
var decorators_js_1 = require("../decorators.js");
var types_js_1 = require("../sites/types.js");
var telemetry_js_1 = require("../telemetry.js");
var _HubSites = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_HubSites, _super);
    function _HubSites() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Gets a Hub Site from the collection by id
     *
     * @param id The Id of the Hub Site
     */
    _HubSites.prototype.getById = function (id) {
        return telemetry_js_1.tag.configure((0, exports.HubSite)(this, "GetById?hubSiteId='" + id + "'"), "hss.getById");
    };
    _HubSites = (0, tslib_1.__decorate)([
        (0, decorators_js_1.defaultPath)("_api/hubsites")
    ], _HubSites);
    return _HubSites;
}(sharepointqueryable_js_1._SharePointQueryableCollection));
exports._HubSites = _HubSites;
exports.HubSites = (0, sharepointqueryable_js_1.spInvokableFactory)(_HubSites);
var _HubSite = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_HubSite, _super);
    function _HubSite() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Gets the ISite instance associated with this hubsite
     */
    _HubSite.prototype.getSite = function () {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var d;
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.select("SiteUrl")()];
                    case 1:
                        d = _a.sent();
                        return [2 /*return*/, (0, types_js_1.Site)(d.SiteUrl)];
                }
            });
        });
    };
    (0, tslib_1.__decorate)([
        (0, telemetry_js_1.tag)("hs.getSite")
    ], _HubSite.prototype, "getSite", null);
    return _HubSite;
}(sharepointqueryable_js_1._SharePointQueryableInstance));
exports._HubSite = _HubSite;
exports.HubSite = (0, sharepointqueryable_js_1.spInvokableFactory)(_HubSite);
//# sourceMappingURL=types.js.map