"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.escapeQueryStrValue = void 0;
var common_1 = require("@pnp/common-commonjs");
var logging_1 = require("@pnp/logging-commonjs");
function escapeQueryStrValue(value) {
    if ((0, common_1.stringIsNullOrEmpty)(value)) {
        return "";
    }
    // replace all instance of ' with ''
    if (/!(@.*?)::(.*?)/ig.test(value)) {
        // to ensure our param aliasing still works we need to treat these special or we'll hear about it
        // so we encode JUST the part that will end up in the url
        return value.replace(/!(@.*?)::(.*)$/ig, function (match, labelName, v) {
            logging_1.Logger.write("Rewriting aliased parameter from match " + match + " to label: " + labelName + " value: " + v, 0 /* Verbose */);
            return "!" + labelName + "::" + encodeURIComponent(v.replace(/'/ig, "''"));
        });
    }
    else {
        return encodeURIComponent(value.replace(/'/ig, "''"));
    }
}
exports.escapeQueryStrValue = escapeQueryStrValue;
//# sourceMappingURL=escapeQueryStrValue.js.map